/* -*- mode:c++ -*- ********************************************************
 * file:        LinearMobility.h
 *
 * author:      Emin Ilker Cetinbas (niw3_at_yahoo_d0t_com)
 *
 * Copyright    (C) 2005 Emin Ilker Cetinbas
 *
 *              This program is free software; you can redistribute it
 *              and/or modify it under the terms of the GNU General Public
 *              License as published by the Free Software Foundation; either
 *              version 2 of the License, or (at your option) any later
 *              version.
 *              For further information see file COPYING
 *              in the top level directory
 ***************************************************************************
 * part of:     framework implementation developed by tkn
 **************************************************************************/


#ifndef LINEAR_MOBILITY_H
#define LINEAR_MOBILITY_H

#include <omnetpp.h>
#include <BasicMobility.h>


/**
 * @brief Linear movement model. See NED file for more info.
 *
 * @ingroup mobility
 * @author Emin Ilker Cetinbas
 */
class LinearMobility : public BasicMobility
{
  protected:
    double angle;          ///< angle of linear motion
    double acceleration;   ///< acceleration of linear motion

    /** @brief always stores the last step for position display update */
    Coord stepTarget;

  public:
    Module_Class_Members( LinearMobility, BasicMobility, 0 );

    /** @brief Initializes mobility model parameters.*/
    virtual void initialize(int);

  protected:
    /** @brief Move the host*/
    virtual void makeMove();

    virtual void fixIfHostGetsOutside();
};

#endif

