/***************************************************************************
 * file:        groups.h
 *
 * author:      Marc Loebbers & Daniel Willkomm
 *
 * copyright:   (C) 2004 Telecommunication Networks Group (TKN) at
 *              Technische Universitaet Berlin, Germany.
 *
 *              This program is free software; you can redistribute it 
 *              and/or modify it under the terms of the GNU General Public 
 *              License as published by the Free Software Foundation; either
 *              version 2 of the License, or (at your option) any later 
 *              version.
 *              For further information see file COPYING 
 *              in the top level directory
 ***************************************************************************
 * part of:     framework implementation developed by tkn
 * description: group definitions for doxygen
 ***************************************************************************
 * changelog:   $Revision: 370 $
 *              last modified:   $Date: 2006-07-06 16:46:04 +0200 (Do, 06 Jul 2006) $
 *              by:              $Author: willkomm $
 ***************************************************************************/

/**
 * @defgroup applLayer applLayer - application layer modules
 */

/**
 * @defgroup netwLayer netwLayer - network layer modules
 */

/**
 * @defgroup nic nic - network interfaces
 */

/**
 * @defgroup macLayer macLayer - MAC layer modules
 * @ingroup nic
 */

/**
 * @defgroup radios radios - radio modules
 * @ingroup nic
 */

/**
 * @defgroup phyLayer phyLayer - physical layer modules
 * @ingroup nic
 */

/**
 * @defgroup snrEval snrEval - modules for attenuation and interference calculation
 * @ingroup phyLayer
 */

/**
 * @defgroup decider decider - decider modules
 * @ingroup phyLayer
 */

/**
 * @defgroup mobility mobility - modules handling the mobility of the hosts
 */

/**
 * @defgroup utils utils  -  utiltity classes
 */


/**
 * @defgroup core core - core MF modules
 */

/**
 * @defgroup basicModules basicModules - basic module classes of the MF
 * @ingroup core
 */

/**
 * @defgroup blackboard blackboard - blackboard related stuff
 * @ingroup core
 */

/**
 * @defgroup channelControl channelControl - channel and connection related classes
 * @ingroup core
 */

/**
 * @defgroup basicUtils basicUtils - utitities for the core MF
 * @ingroup core
 */
