/***************************************************************************
 * file:        mainpage.h
 *
 * author:      Daniel Willkomm
 *
 * copyright:   (C) 2004 Telecommunication Networks Group (TKN) at
 *              Technische Universitaet Berlin, Germany.
 *
 *              This program is free software; you can redistribute it 
 *              and/or modify it under the terms of the GNU General Public 
 *              License as published by the Free Software Foundation; either
 *              version 2 of the License, or (at your option) any later 
 *              version.
 *              For further information see file COPYING 
 *              in the top level directory
 ***************************************************************************
 * part of:     framework implementation developed by tkn
 * description: - part of the documentation
 *              - mainpage for the doxygen documentation
 ***************************************************************************
 * changelog:   $Revision: 410 $
 *              last modified:   $Date: 2007-01-12 08:28:55 +0100 (Fr, 12 Jan 2007) $
 *              by:              $Author: willkomm $
 ***************************************************************************/

/**
@mainpage Mobility Framework (MF) API Reference


The MF API Reference can be browsed in several ways (see links at top
of this page):

    - <b>Modules</b> -- the most important classes, grouped by functionality
    - <b>Class Hierarchy</b> -- inheritance tree of all classes
    - <b>Alphabetical List</b> -- alphabetical list of all classes
    - <b>Compound List</b> -- list of all classes with brief descriptions
    - <b>File List</b> -- list of all header files
    - <b>Compound Members</b> -- all documented class members in alphabetical order

The best place to get started with is <b>Modules</b> --> @ref core --> @ref basicModules.


<hr>

Other placers to look at are:
@htmlonly
  <ul>
    <li><a href="../manual/index.html" target="_blank">MF Manual</a></li>
    <li><a href="../neddoc/index.html" target="_blank">MF Neddoc Reference</a></li>
    <li><a href="../hp/docu.html" target="_blank">Documenation Guidelines</a></li>
    <li><a href="../hp/groups.html" target="_blank">Module Groups</a></li>
    <li><a href="../hp/coding.html" target="_blank">Coding Guidelines</a></li>
    <li><a href="../hp/omnetCoding.html" target="_blank">OMNeT++ Coding Conventions / Style Guide</a></li>
    <li><a href="http://sourceforge.net/projects/mobility-fw/" target="_blank">Sourceforge Project Page</a></li>
  </ul>
@endhtmlonly

*/



